package com.zy.bms.service;


import com.zy.bms.entity.DeviceBase;
import com.zy.bms.pojo.io.set.SetIO;

/**
 * 向设备发送协议消息 服务类
 *
 * @author yangxiaokun
 * @since 2021-06-03
 */
public interface IPostMqttMsgService {

    /**
     * 发送设置指令
     *
     * @param io 设置参数
     */
    void set(SetIO io);

    /**
     * 处理设备注册请求
     * 返回登录密码
     *
     * @param device 设备信息
     */
    void handleRegister(DeviceBase device);

    /**
     * 获取设备本地设置
     *
     * @param openNum 设备码
     */
    void getDeviceLocalSet(String openNum);
}
